import { computed as f, ref as k, watch as I, onMounted as X, openBlock as n, createElementBlock as r, normalizeStyle as g, createElementVNode as d, toDisplayString as _, createCommentVNode as y, unref as b, Fragment as D, renderList as P, normalizeClass as N, createBlock as W } from "vue";
import { u as J, c as U, t as K, a as Q, p as i, d as C, b as R, o as Y, e as O, g as Z, f as V, X as ee, s as te, w as le, i as ae } from "./index-DQl1TFXa.js";
import { u as G } from "./useNestedProp-lmeFt-ev.js";
import oe from "./vue-ui-skeleton-BVJGmYjj.js";
import { _ as se } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const ne = ["xmlns", "viewBox"], re = ["id"], ue = ["stop-color"], ie = ["stop-color"], ce = ["stop-color"], de = {
  id: "stackPill",
  clipPathUnits: "objectBoundingBox"
}, ve = ["fill"], ge = {
  key: 0,
  "clip-path": "url(#stackPill)"
}, pe = ["height", "width", "fill"], he = ["onClick", "x", "width", "height", "fill", "stroke"], fe = ["width", "height", "rx"], ye = ["onClick"], me = { style: { display: "flex", "flex-direction": "row", "align-items": "center", gap: "4px", "justify-content": "center" } }, ke = ["height", "width"], _e = ["fill"], be = {
  __name: "vue-ui-sparkstackbar",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectDatapoint"],
  setup(M, { emit: T }) {
    const u = M, { vue_ui_sparkstackbar: q } = J(), z = f(() => !!u.dataset && u.dataset.length), A = k(U()), e = f({
      get: () => L(),
      set: (t) => t
    });
    function L() {
      const t = G({
        userConfig: u.config,
        defaultConfig: q
      });
      return t.theme ? {
        ...G({
          userConfig: K.vue_ui_sparkstackbar[t.theme] || u.config,
          defaultConfig: t
        }),
        customPalette: Q[t.theme] || i
      } : t;
    }
    I(() => u.config, (t) => {
      e.value = L(), B();
    }, { deep: !0 }), I(() => u.dataset, (t) => {
      m.value = u.dataset.map((a, l) => ({
        ...a,
        color: a.color ? C(a.color) : x.value[l] || i[l] || i[l % i.length]
      }));
    }, { deep: !0 });
    const x = f(() => R(e.value.customPalette)), m = k(u.dataset.map((t, a) => ({
      ...t,
      value: e.value.style.animation.show ? 0 : t.value || 0,
      color: t.color ? C(t.color) : x.value[a] || i[a] || i[a % i.length]
    }))), w = k(!0);
    X(() => {
      if (B(), e.value.style.animation.show) {
        let h = function() {
          o += l / t, o < l ? (m.value = m.value.map((s, c) => ({
            ...s,
            value: s.value += a[c],
            color: s.color ? C(s.color) : x.value[c] || i[c] || i[c % i.length]
          })), requestAnimationFrame(h)) : (w.value = !1, m.value = u.dataset.map((s, c) => ({
            ...s,
            value: s.value || 0,
            color: s.color ? C(s.color) : x.value[c] || i[c] || i[c % i.length],
            id: U()
          })));
        };
        const t = e.value.style.animation.animationFrames, a = u.dataset.map((s, c) => s.value / t), l = u.dataset.map((s) => s.value || 0).reduce((s, c) => s + c, 0);
        let o = 0;
        w.value = !0, h();
      }
    });
    function B() {
      Y(u.dataset) ? O({
        componentName: "VueUiSparkStackbar",
        type: "dataset"
      }) : u.dataset.forEach((t, a) => {
        Z({
          datasetObject: t,
          requiredAttributes: ["name", "value"]
        }).forEach((l) => {
          O({
            componentName: "VueUiSparkStackbar",
            type: "datasetSerieAttribute",
            property: l,
            index: a
          });
        });
      });
    }
    const p = k({
      width: 500,
      height: 16
    }), v = k([]), F = f(() => u.dataset.map((t) => t.value || 0).filter((t, a) => !v.value.includes(a)).reduce((t, a) => t + a, 0)), j = f(() => m.value.map((t, a) => {
      const l = t.value || 0, o = l / F.value, h = isNaN(o) ? 0 : o, s = h * p.value.width;
      return {
        ...t,
        value: l,
        proportion: h,
        width: s,
        proportionLabel: V({
          v: h * 100,
          s: "%",
          r: e.value.style.legend.percentage.rounding
        })
      };
    })), $ = f(() => j.value.filter((t, a) => !v.value.includes(a)));
    function H(t) {
      v.value.includes(t) ? v.value = v.value.filter((a) => a !== t) : v.value.length < m.value.length - 1 && v.value.push(t);
    }
    const S = f(() => {
      let t = 0;
      const a = [];
      for (let l = 0; l < $.value.length; l += 1)
        a.push({
          ...$.value[l],
          start: t
        }), t += $.value[l].width;
      return a;
    });
    function E(t, a) {
      T("selectDatapoint", { datapoint: t, index: a });
    }
    return (t, a) => (n(), r("div", {
      style: g(`width:100%; background:${e.value.style.backgroundColor}`)
    }, [
      e.value.style.title.text ? (n(), r("div", {
        key: 0,
        style: g(`width:calc(100% - 12px);background:transparent;margin:0 auto;margin:${e.value.style.title.margin};padding: 0 6px;text-align:${e.value.style.title.textAlign}`)
      }, [
        d("div", {
          style: g(`font-size:${e.value.style.title.fontSize}px;color:${e.value.style.title.color};font-weight:${e.value.style.title.bold ? "bold" : "normal"}`)
        }, _(e.value.style.title.text), 5),
        e.value.style.title.subtitle.text ? (n(), r("div", {
          key: 0,
          style: g(`font-size:${e.value.style.title.subtitle.fontSize}px;color:${e.value.style.title.subtitle.color};font-weight:${e.value.style.title.subtitle.bold ? "bold" : "normal"}`)
        }, _(e.value.style.title.subtitle.text), 5)) : y("", !0)
      ], 4)) : y("", !0),
      z.value ? (n(), r("svg", {
        key: 1,
        xmlns: b(ee),
        width: "100%",
        viewBox: `0 0 ${p.value.width} ${p.value.height}`
      }, [
        d("defs", null, [
          (n(!0), r(D, null, P(S.value, (l, o) => (n(), r("linearGradient", {
            key: `stack_gradient_${o}`,
            gradientTransform: "rotate(90)",
            id: `stack_gradient_${o}_${A.value}`
          }, [
            d("stop", {
              offset: "0%",
              "stop-color": l.color
            }, null, 8, ue),
            d("stop", {
              offset: "50%",
              "stop-color": b(te)(b(le)(l.color, 0.05), 100 - e.value.style.bar.gradient.intensity)
            }, null, 8, ie),
            d("stop", {
              offset: "100%",
              "stop-color": l.color
            }, null, 8, ce)
          ], 8, re))), 128)),
          d("clipPath", de, [
            d("rect", {
              x: "0.005",
              y: "-2",
              width: "0.99",
              height: "5",
              rx: "3",
              ry: "3",
              fill: e.value.style.backgroundColor
            }, null, 8, ve)
          ])
        ]),
        F.value > 0 ? (n(), r("g", ge, [
          d("rect", {
            x: 0,
            y: 0,
            height: p.value.height,
            width: S.value.map((l) => l.width).reduce((l, o) => l + o, 0),
            fill: e.value.style.bar.gradient.underlayerColor,
            class: N({ animated: !w.value })
          }, null, 10, pe),
          (n(!0), r(D, null, P(S.value, (l, o) => (n(), r("rect", {
            key: `stack_${o}`,
            onClick: () => E(l, o),
            x: l.start,
            y: 0,
            width: l.width,
            height: p.value.height,
            fill: e.value.style.bar.gradient.show ? `url(#stack_gradient_${o}_${A.value})` : l.color,
            stroke: e.value.style.backgroundColor,
            "stroke-linecap": "round",
            class: N({ animated: !w.value })
          }, null, 10, he))), 128))
        ])) : (n(), r("rect", {
          key: 1,
          x: 2,
          y: 1,
          width: p.value.width - 4,
          height: p.value.height - 2,
          stroke: "#CCCCCC",
          "stroke-width": "2",
          fill: "transparent",
          rx: (p.value.height - 4) / 2
        }, null, 8, fe))
      ], 8, ne)) : y("", !0),
      z.value ? y("", !0) : (n(), W(oe, {
        key: 2,
        config: {
          type: "sparkStackbar",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            sparkStackbar: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      e.value.style.legend.show ? (n(), r("div", {
        key: 3,
        style: g(`background:transparent;margin:0 auto;margin:${e.value.style.legend.margin};justify-content:${e.value.style.legend.textAlign === "left" ? "flex-start" : e.value.style.legend.textAlign === "right" ? "flex-end" : "center"}`),
        class: "vue-ui-sparkstackbar-legend"
      }, [
        (n(!0), r(D, null, P(j.value, (l, o) => (n(), r("div", {
          style: g(`font-size:${e.value.style.legend.fontSize}px;`),
          class: N({ "vue-ui-sparkstackbar-legend-item": !0, "vue-ui-sparkstackbar-legend-item-unselected": v.value.includes(o) }),
          onClick: (h) => {
            H(o), E(l, o);
          }
        }, [
          d("div", me, [
            (n(), r("svg", {
              height: `${e.value.style.legend.fontSize}px`,
              width: `${e.value.style.legend.fontSize}px`,
              viewBox: "0 0 10 10"
            }, [
              d("circle", {
                cx: 5,
                cy: 5,
                r: 5,
                fill: l.color
              }, null, 8, _e)
            ], 8, ke)),
            d("span", {
              style: g(`color:${e.value.style.legend.name.color}; font-weight:${e.value.style.legend.name.bold ? "bold" : "normal"}`)
            }, _(l.name), 5),
            e.value.style.legend.percentage.show ? (n(), r("span", {
              key: 0,
              style: g(`font-weight:${e.value.style.legend.percentage.bold ? "bold" : "normal"};color:${e.value.style.legend.percentage.color}`)
            }, _(v.value.includes(o) ? " - " : l.proportionLabel), 5)) : y("", !0),
            e.value.style.legend.value.show ? (n(), r("span", {
              key: 1,
              style: g(`font-weight:${e.value.style.legend.value.bold ? "bold" : "normal"};color:${e.value.style.legend.value.color}`)
            }, " (" + _(b(ae)(
              e.value.style.legend.value.formatter,
              l.value,
              b(V)({
                p: e.value.style.legend.value.prefix,
                v: l.value,
                s: e.value.style.legend.value.suffix,
                r: e.value.style.legend.value.rounding
              }),
              { datapoint: l, seriesIndex: o }
            )) + ") ", 5)) : y("", !0)
          ])
        ], 14, ye))), 256))
      ], 4)) : y("", !0)
    ], 4));
  }
}, De = /* @__PURE__ */ se(be, [["__scopeId", "data-v-25e78abf"]]);
export {
  De as default
};
